/**************---< TECHNO ROAD.inc >---**************/
/*                                                   */
/*   File        :coron_usbcdc.h                     */
/*   Version     :v3.0.0                             */
/*   Date        :2014/05/09                         */
/*   Author      :                                   */
/*   Description :Coron USB CDC Library Header       */
/*                                                   */
/*    Copyright(C) TECHNO ROAD Inc.                  */
/*                 http://techno-road.com/           */
/*****************************************************/

#ifndef CORON_USBCDC_H_
#define CORON_USBCDC_H_

#define MASS_MEMORY_START     0x04002000
#define BULK_MAX_PACKET_SIZE  0x00000040

extern vu8 buffer_out[];
extern vu8 buffer_in[];

extern vu32 count_out;
extern vu32 count_in;

extern void Set_USBClock(void);
extern void Enter_LowPowerMode(void);
extern void Leave_LowPowerMode(void);
extern void USB_Interrupts_Config(void);
extern void USB_Cable_Config(FunctionalState NewState);

extern void Get_SerialNum(void);

#define CORON_USB_CONNECT		GPIO_SetBits(GPIOA, GPIO_Pin_10)
#define CORON_USB_DISCONNECT	GPIO_ResetBits(GPIOA, GPIO_Pin_10)

#define USB_DISCONNECT            GPIOB
#define USB_DISCONNECT_PIN        GPIO_Pin_14
#define RCC_APB2Periph_GPIO_DISCONNECT      RCC_APB2Periph_GPIOB

#endif /*CORON_USBCDC_H_*/
