/**************---< TECHNO ROAD.inc >---**************/
/*                                                   */
/*   File        :coron_sdtxt.c                      */
/*   Version     :v3.0.0                             */
/*   Date        :2014/05/09                         */
/*   Author      :                                   */
/*   Description :SD Text File R&W Library Source    */
/*                                                   */
/*    Copyright(C) TECHNO ROAD Inc.                  */
/*                 http://techno-road.com/           */
/*****************************************************/
#include "coron_conf.h"
#ifdef _CORON_SD
#ifdef _CORON_SDTXT
/* Includes ------------------------------------------------------------------*/
#include "stm32f10x_lib.h"
#include "coron_lib.h"

/* Global variables ----------------------------------------------------------*/
u32	txt_dir_sector=0;			//txtt@CfBNg̃ZN^ԍ
u32 txt_sector_num[50];		//etxtt@C̃ZN^ԍ
u32 txt_size[50];			//txtt@C̃TCY
char txt_name[50][8];		//txtt@C̖O
u8 txt_count;				//"TextData"tH_txtt@C̐

//==============================================================================
// SDJ[htxtt@C
//==============================================================================
void SD_search_txt(void){
	txt_dir_sector=SD_searchDirectory("TEXTDA");
	txt_count=SD_getFileList(txt_dir_sector,"TXT",txt_name,txt_sector_num,txt_size);
}

//==============================================================================
// SDJ[hTXTt@CUSBCDCĐ(t@Cԍ)
//==============================================================================
#ifdef _CORON_USBCDC
void SD_txt_USBput(u8 txt_num,u8 header_flag){
	u32 size;
	u32 sct,sec_num,n,i;
	u32 last_byte_num;
	size =txt_size[txt_num];
	sct  =txt_sector_num[txt_num];

	//TXTt@Cf[^ZN^|1
	sec_num=(size/512);
	//Ō̃ZN^̃oCg|1
	last_byte_num=(size%512)-1;
	//wb_̕\
	if(header_flag){
		USB_puts("\r\n\n");
		USB_puts("*******************************\r\n");
		USB_puts("*   [SD Card Text File Put]   *\r\n");
		USB_puts("*******************************\r\n");
		USB_puts("  File Number =");
		USB_putn(txt_num,3);
		USB_puts("\r\n");
		USB_puts("  File Name   = ");
		USB_putd(&txt_name[txt_num][0],8);
		USB_puts("\r\n");
		USB_puts("  File Size   =");
		USB_putn(txt_size[txt_num],8);
		USB_puts("[Byte]\r\n");
		USB_puts("  File Sector =");
		USB_putn(txt_sector_num[txt_num],8);
		USB_puts("\r\n");
		USB_puts("*******************************\r\n");
		USB_puts("Text Start...\r\n");
		USB_puts("*******************************\r\n");
	}
	//t@C̒g\
    for(n=0;n<(sec_num);n++){
    	SD_read(512*(n + sct));
        for(i=0;i<512;i++){
        	USB_putc(buf512[i]);
        }
    }
	//Ō̃ZN^ǂݍ(f[^΂)
    SD_read(512*(sct+sec_num));
    for(i=0;i<=last_byte_num;i++){
    	USB_putc(buf512[i]);
    }

	if(header_flag){
	    USB_puts("\r\n*******************************\r\n");
		USB_puts("Text End...\r\n");
		USB_puts("*******************************\r\n\n");
	}
}
#endif

//==============================================================================
// SDJ[hTXTt@CUART(XBee)Đ(t@Cԍ)
//==============================================================================
#ifdef _CORON_UART
void SD_txt_UARTput(u8 txt_num,u8 header_flag){
	u32 size;
	u32 sct,sec_num,n,i;
	u32 last_byte_num;
	size =txt_size[txt_num];
	sct  =txt_sector_num[txt_num];

	//TXTt@Cf[^ZN^|1
	sec_num=(size/512);
	//Ō̃ZN^̃oCg|1
	last_byte_num=(size%512)-1;

	if(header_flag){
		UART_puts("\r\n\n");
		UART_puts("*******************************\r\n");
		UART_puts("*   [SD Card Text File Put]   *\r\n");
		UART_puts("*******************************\r\n");
		UART_puts("  File Number =");
		UART_putn(txt_num,3);
		UART_puts("\r\n");
		UART_puts("  File Name   = ");
		UART_putd(&txt_name[txt_num][0],8);
		UART_puts("\r\n");
		UART_puts("  File Size   =");
		UART_putn(txt_size[txt_num],8);
		UART_puts("[Byte]\r\n");
		UART_puts("  File Sector =");
		UART_putn(txt_sector_num[txt_num],8);
		UART_puts("\r\n");
		UART_puts("*******************************\r\n");
		UART_puts("Text Start...\r\n");
		UART_puts("*******************************\r\n");
	}

    for(n=0;n<(sec_num);n++){
    	SD_read(512*(n + sct));
        for(i=0;i<512;i++){
        	UART_putc(buf512[i]);
        }
    }
	//Ō̃ZN^ǂݍ(f[^΂)
    SD_read(512*(sct+sec_num));
    for(i=0;i<=last_byte_num;i++){
    	UART_putc(buf512[i]);
    }

	if(header_flag){
	    UART_puts("\r\n*******************************\r\n");
		UART_puts("Text End...\r\n");
		UART_puts("*******************************\r\n\n");
	}
}
#endif

//==============================================================================
// SDJ[hTXTt@C 1Ǎ(t@CԍAԍ)
//==============================================================================
char SD_txt_read_c(u8 txt_num,u32 s_num){
	u16 buf_num=0;
	u32 sct;

	buf_num = (s_num%512);						  		//w̕ۑĂoCgԍ
	sct		= txt_sector_num[txt_num]+(s_num/512);		//w̕ۑĂZN^ԍ
    SD_read(512*sct);									//Ǎ݂oCgZN^Ǎ

    return buf512[buf_num];
}

//==============================================================================
// SDJ[hTXTt@C 1(t@CԍAԍAޕ)
//==============================================================================
void SD_txt_write_c(u8 txt_num,u32 s_num,char wbuf){
	u16 buf_num=0;
	u32 sct;

	if(s_num <= txt_size[txt_num]){
		buf_num = (s_num%512);						  	//w̕ۑĂoCgԍ
		sct		= txt_sector_num[txt_num]+(s_num/512);	//w̕ۑĂZN^ԍ
		SD_read(512*sct);								//݂oCgZN^Ǎ
		buf512[buf_num]=wbuf;							//Pobt@ւ
		SD_write(512*sct);								//݂oCgZN^
	}
}

//==============================================================================
// SDJ[hTXTt@C Ǎ(t@CԍAԍAAǍޕ)
//==============================================================================
void SD_txt_read_s(u8 txt_num,u32 s_num,char* buf,u16 len){
	u16 buf_num=0,i=0;
	u16 buf_bit=0;
	u32 sct;

	for(i=0;i<len;i++){
		buf_num = ((s_num+i)%512);						  //w̕ۑĂoCgԍ
		sct		= txt_sector_num[txt_num]+((s_num+i)/512);//w̕ۑĂZN^ԍ

		//ZN^܂ꍇ
		if((buf_num+len)>512){
			buf_bit = (buf_num+len)-512;	//PZN^R镪
			//O
			SD_read(512*sct);				//ZN^Ǎ
			for(i=0;i<(len-buf_bit);i++){	//f[^i[
				buf[i]=buf512[buf_num+i];
			}

			//㔼
			SD_read(512*(sct+1));			//ZN^Ǎ
			for(i=0;i<buf_bit;i++){			//f[^i[
				buf[(len-buf_bit)+i]=buf512[i];
			}
		}
		//ZN^܂Ȃꍇ
		else{
			SD_read(512*sct);
			for(i=0;i<len;i++){
				buf[i]=buf512[buf_num+i];
			}
		}
	}
}

//==============================================================================
// SDJ[hTXTt@C 񏑍(t@CԍAԍAAǍޕ)
//==============================================================================
void SD_txt_write_s(u8 txt_num,u32 s_num,char* buf,u16 len){
	u16 buf_num=0,i=0;
	u16 buf_bit=0;
	u32 sct;

	if((s_num+len) <= txt_size[txt_num]){
		buf_num = (s_num%512);						  //w̕ۑĂoCgԍ
		sct		= txt_sector_num[txt_num]+(s_num/512);//w̕ۑĂZN^ԍ

		//ZN^܂ꍇ
		if((buf_num+len)>512){
			buf_bit = (buf_num+len)-512;	//PZN^R镪
			//O
			SD_read(512*sct);				//ZN^Ǎ
			for(i=0;i<(len-buf_bit);i++){	//f[^i[
				buf512[buf_num+i]=buf[i];
			}
			SD_write(512*sct);				//ZN^

			//㔼
			SD_read(512*(sct+1));			//ZN^Ǎ
			for(i=0;i<buf_bit;i++){			//f[^i[
				buf512[i]=buf[(len-buf_bit)+i];
			}
			SD_write(512*(sct+1));			//ZN^
		}
		//ZN^܂Ȃꍇ
		else{
			SD_read(512*sct);
			for(i=0;i<len;i++){
				buf512[buf_num+i]=buf[i];
			}
			SD_write(512*sct);
		}
	}
}

#endif
#endif
